Gecode::SetExpr Class Reference

Set expressions More...

`#include <minimodel.hh>`

## Classes

class | Node
| Node for set expression More...

## Public Types

enum | NodeType { NT_VAR , NT_CONST , NT_LEXP , NT_CMPL , NT_INTER , NT_UNION , NT_DUNION }
| Type of set expression. More...

## Public Member Functions

| SetExpr (void)
| Default constructor.
| SetExpr (const SetExpr &e)
| Copy constructor.
| SetExpr (const SetExpr &l, NodeType t, const SetExpr &r)
| Construct expression for type and subexpresssions.
| SetExpr (const SetVar &x)
| Construct expression for variable.
| SetExpr (const LinIntExpr &x)
| Construct expression for integer variable.
| SetExpr (const IntSet &s)
| Construct expression for constant.
| SetExpr (const SetExpr &e, NodeType t)
| Construct expression for negation.
SetVar | post (Home home) const
| Post propagators for expression.
void | post (Home home, SetRelType srt, const SetExpr &e) const
| Post propagators for relation.
void | post (Home home, BoolVar b, bool t, SetRelType srt, const SetExpr &e) const
| Post propagators for reified relation.
const SetExpr & | operator= (const SetExpr &e)
| Assignment operator.
| ~SetExpr (void)
| Destructor.

## Detailed Description

Set expressions

Definition at line 1164 of file minimodel.hh.

## Member Enumeration Documentation

## NodeType

enum Gecode::SetExpr::NodeType

Type of set expression.

Enumerator
NT_VAR | Variable.
NT_CONST | Constant.
NT_LEXP | Linear expression.
NT_CMPL | Complement.
NT_INTER | Intersection.
NT_UNION | Union.
NT_DUNION | Disjoint union.

Definition at line 1167 of file minimodel.hh.

## Constructor & Destructor Documentation

## SetExpr() [1/7]

Gecode::SetExpr::SetExpr | ( | void |  | ) |

inline

Default constructor.

Definition at line 44 of file set-expr.hpp.

## SetExpr() [2/7]

Gecode::SetExpr::SetExpr | ( | const SetExpr & | e | ) |

Copy constructor.

Definition at line 644 of file set-expr.cpp.

## SetExpr() [3/7]

Gecode::SetExpr::SetExpr | ( | const SetExpr & | l,
|  | NodeType | t,
|  | const SetExpr & | r )

Construct expression for type and subexpresssions.

Definition at line 600 of file set-expr.cpp.

## SetExpr() [4/7]

Gecode::SetExpr::SetExpr | ( | const SetVar & | x | ) |

Construct expression for variable.

Definition at line 576 of file set-expr.cpp.

## SetExpr() [5/7]

Gecode::SetExpr::SetExpr | ( | const LinIntExpr & | x | ) |

explicit

Construct expression for integer variable.

Definition at line 592 of file set-expr.cpp.

## SetExpr() [6/7]

Gecode::SetExpr::SetExpr | ( | const IntSet & | s | ) |

Construct expression for constant.

Definition at line 584 of file set-expr.cpp.

## SetExpr() [7/7]

Gecode::SetExpr::SetExpr | ( | const SetExpr & | e,
|  | NodeType | t )

Construct expression for negation.

Definition at line 612 of file set-expr.cpp.

## ~SetExpr()

Gecode::SetExpr::~SetExpr | ( | void |  | ) |

Destructor.

Definition at line 639 of file set-expr.cpp.

## Member Function Documentation

## post() [1/3]

SetVar Gecode::SetExpr::post | ( | Home | home | ) | const

Post propagators for expression.

Definition at line 649 of file set-expr.cpp.

## post() [2/3]

void Gecode::SetExpr::post | ( | Home | home,
|  | SetRelType | srt,
|  | const SetExpr & | e ) const

Post propagators for relation.

Definition at line 658 of file set-expr.cpp.

## post() [3/3]

void Gecode::SetExpr::post | ( | Home | home,
|  | BoolVar | b,
|  | bool | t,
|  | SetRelType | srt,
|  | const SetExpr & | e ) const

Post propagators for reified relation.

Definition at line 663 of file set-expr.cpp.

## operator=()

const SetExpr & Gecode::SetExpr::operator= | ( | const SetExpr & | e | ) |

Assignment operator.

Definition at line 629 of file set-expr.cpp.

The documentation for this class was generated from the following files:

- gecode/minimodel.hh
- gecode/minimodel/set-expr.cpp
- gecode/minimodel/set-expr.hpp